// Experimentos con cadenas (strings) en C
#include <stdio.h>
#include <string.h>
#include <malloc.h>

int main()
{
  // Una cadena se puede guardar en un array de caracteres, o en una
  // zona de memoria a la que se hace apuntar un puntero a caracteres.

  char diez[10]="Holas"; // Reservamos 10 caracteres, aunque usamos
			 // solo 6 (letras mas terminador)
  char fija[]="Holas";   // El compliador calcula aqui cuantos bytes
			 // reservar (seran 6)
  char *puntero="Holas"; // Aqui la cadena se almacena en el area de
			 // "strings estaticos", y se hace que el
			 // puntero apunte a ella

  // Sorpresa?
  printf("Tamao de diez=%d\n", sizeof(diez));
  printf("Tamao de fija=%d\n", sizeof(fija));
  printf("Tamao de puntero=%d\n", sizeof(puntero)); // !Eepa!
  
  // Aqui no hay sorpresa
  printf("Cadena diez.    Longitud=%d, contenido=|%s|\n", 
	 strlen(diez), diez);
  printf("Cadena fija.    Longitud=%d, contenido=|%s|\n", 
	 strlen(fija), fija);
  printf("Cadena puntero. Longitud=%d, contenido=|%s|\n", 
	 strlen(puntero), puntero);

  // La sintaxis para accedera a una letra cualquiera es la misma en
  // los tres casos.
  printf("Tercera letra: diez=%c, fija=%c, puntero=%c\n", 
	 diez[2], fija[2], puntero[2]);

  // La zona de memoria donde se almacenan los arrays es la misma (la
  // pila de programa durante la ejecucion de main). En cambio la
  // cadena estatica va a otra zona (la zona de strings estaticos)
  printf("Direcciones de memoria donde se almacena el texto:\n");
  printf("  diez   =%p\n", diez);
  printf("  fija   =%p\n", fija);
  printf("  puntero=%p\n", puntero);
  printf(" &puntero=%p\n", &puntero); // Observar que el puntero se
  // almacena en la pila, al ser una variable de main, aunque la
  // direccion a que apunta no esta en la pila.

  // Modificaciones de las cadenas.
  printf("Aadir texto a la cadena fija [error grave]\n");
  strcat(fija, ", caracolas");
  printf("Resultado:\n");  // Inesperado?
  printf(" Cadena fija.    Longitud=%d, contenido=|%s|\n", 
	 strlen(fija), fija);
  printf(" Cadena diez.    Longitud=%d, contenido=|%s|\n", 
	 strlen(diez), diez);

  printf("Aadir texto a la cadena puntero [mal hecho]\n");
  strcat(puntero, ", caracolas");
  printf("Resultado:\n");
  printf(" Cadena puntero. Longitud=%d, contenido=|%s|\n", 
	 strlen(puntero), puntero);
  // Lo anterior puede dar un core o no, depende de la maquina

  printf("Aadir texto a la cadena puntero [bien hecho]\n");
  puntero=(char *) malloc(strlen(puntero)+strlen(", caracolas")+1);
  strcpy(puntero, "Holas");
  strcat(puntero, ", caracolas");
  printf("Resultado:\n");
  printf(" Cadena puntero. Longitud=%d, contenido=|%s|\n", 
	 strlen(puntero), puntero);
  // Aqui no hay problema. Es la forma correcta de hacerlo. Pero ahora
  // el puntero ya no apunta a la zona de strings estaticos, sino al
  // "heap" (la zona de memoria sobre la que opera malloc/free). La
  // cadena original "Holas", sigue intacta en la zona de stings
  // estaticos. El puntero a ella se ha perdido para siempre.

  return 0;
}
